import defaultConfig from './config'
import { mergeDeep } from './utils'
import ProgressBar from './components/progressBar'

export default {
  progressBartInstance: null,

  install(Vue, config) {

    config = mergeDeep(defaultConfig, config)

    this.progressBartInstance = this.createProgressBarComponent(Vue, ProgressBar)

    const dispatcher = {
      start: options => this.progressBartInstance.$emit('dispatch', { action: 'start', options }),
      finish: options => this.progressBartInstance.$emit('dispatch', { action: 'finish', options })
    }
    Object.assign(this, dispatcher)
    Vue[config.name] = Vue.prototype[config.name] = dispatcher
  },

  createProgressBarComponent(VueConsturctor, progressBarCmpt) {
    let progressBarConstructor = VueConsturctor.extend(progressBarCmpt)
    const instance = new progressBarConstructor().$mount()

    document.body.appendChild(instance.$el)

    return instance
  }
}